
from unittest.mock import patch
from odoo.addons.saas_worker import metabase
from odoo.addons.saas_worker.util import version_gte
from odoo.addons.saas_worker.auth_util import tokenize_param
from odoo.addons.saas_trial.tests.common import TestTrialCommon, tagged


@tagged('post_install', '-at_install', 'post_saas_trial_creation')
class TestTrialSelfActivation(TestTrialCommon):

    def test_resend_activation_frontend(self):
        if version_gte("16.0"):
            # >=16.0, only the backend systray activation is used
            self.skipTest("Skip, only for version before 16.0")

        # force database as to be activated
        metabase.set_expiry_in(self.env.cr.dbname, '4 hours', set_status='to_activate')
        with patch('requests.post') as request_post_mock:
            request_post_mock.return_value.json.return_value = {'result': {'confirm_token': tokenize_param('test-confirm-token')}}
            self.start_tour('/', 'trial_resend_activation_email_frontend', login=self.user_admin.login)
            request_post_mock.assert_called_once()
